import std.string;
import std.process;
import std.conv;
import std.json;
import std.range;
import std.algorithm;
import std.typecons;
import std.traits;

string passSliceToZig(T)(T[] a, string type)
{
    return format("%s{%s}", type, to!(char[])(a)[1..$-1]);
}

// the `get` method on JSONValue doesn't support nested array types or nullables
T getJSON(T)(JSONValue v)
{
    static if (is(typeof(v.get!T())))
    {
        return v.get!T();
    }
    else static if (is(typeof(getJSON!(ElementType!(T))(v))))
    {
        return array(v.get!(JSONValue[])().map!(x => getJSON!(ElementType!(T))(x)));
    }
    else static if (__traits(isSame, TemplateOf!T, Nullable) && is(typeof(getJSON!(TemplateArgsOf!T[0])(v))))
    {
        T x;
        if (v.isNull)
            x.nullify();
        else
            x = T(getJSON!(TemplateArgsOf!T[0])(v));
        return x;
    }
}

T glueCall(T)(string file, string expr)
{
    auto r = execute(["raku", "gluebus.raku", file, expr]);
    try {
    return getJSON!T(parseJSON(r.output));
    } catch (JSONException e)
    {
        import std.stdio;
        writeln(r.output);
        return getJSON!T(parseJSON(r.output));
    }
}
